#include <iostream>
#include <vector>
#include <fstream>
using namespace std;

ifstream f("muguros.in");
ofstream g("muguros.out");

int px[1035], py[1035], ps[2075], nx, ny, ns;
int x, y;
int c;
int l, r, k;

void make_powers() {
    f >> x >> y;
    if (x == 0 || x == 1) px[++nx] = x;
    else {
        long long q = 1;
        while (q <= 1e9) {
            px[++nx] = q;
            q *= x;
        }
    }
    if (y == 0 || y == 1) py[++ny] = y;
    else {
        long long q = 1;
        while (q <= 1e9) {
            py[++ny] = q;
            q *= y;
        }
    }
    for (int i=1;i<=nx;i++) {
        for (int j=1;j<=ny;j++) {
            if (px[i] + py[j] <= 1e9) {
                ps[++ns] = px[i] + py[j];
            }
        }
    }
    for (int i=1;i<=ns;i++) {
        for (int j=i+1;j<=ns;j++) {
            if (ps[i] > ps[j]) {
                swap(ps[i], ps[j]);
            }
            else if (ps[i] == ps[j]) {
                ps[j] = 1e9 + 1;
            }
        }
    }
    while (ps[ns] == 1e9 + 1) ns--;
    ps[++ns] = 1e9 + 1;
}

void solve_1() {
    f >> k;
    bool ok = false;
    for (int i=1;i<=ns;i++) {
        ok = ok || (ps[i] == k);
    }
    g << (ok ? "DA" : "NU");
}

void solve_2() {
    f >> l >> r;
    int max_len = 0, max_l = -1, max_r = -1;
    for (int i=1;i<=ns;i++) {
        if (ps[i] <= l) continue;
        if (ps[i-1] >= r) break;
        int cl = max(ps[i-1]+1, l);
        int cr = min(ps[i]-1, r);
        if (cr - cl + 1 > max_len) {
            max_len = cr - cl + 1;
            max_l = cl;
            max_r = cr;
        }
    }
    g << max_l << " " << max_r;
}

int main() {
    f >> c;
    make_powers();
    if (c == 1) solve_1();
    else solve_2();
    
    return 0;
}